#include "utils.h"
#include <stdio.h>

void hexdump(void* data, size_t length)
{
    for (size_t read = 0; read < length; read += 16) {
        printf("%04zx", read);

        size_t to_read = length - read > 16 ? 16 : length - read;
        for (size_t byte = 0; byte < to_read; byte++) {
            printf(" %02X", ((unsigned char*)data)[read + byte]);
        }

        printf("\n");
    }
}

