#include <stdio.h>
#include <unistd.h>
#include "skiller.h"
#include "usb.h"
#include "utils.h"

void stuff(libusb_device *skiller)
{
    libusb_device_handle *handle;
    skillerctl_packet_t packet;

    if (skiller == NULL) {
        printf("Device not found kurwa.\n");
        return;
    }


    if (libusb_open(skiller, &handle) != LIBUSB_SUCCESS) {
        printf("Nie udało się nawiązać połączenia kurwa..\n");
        return;
    }

    printf("Hura kurwa.\n");

    libusb_detach_kernel_driver(handle, 1);
    libusb_claim_interface(handle, 1);

/*     skillerctl_enable_command(&packet); */
/*     skillerctl_send_command(handle, &packet); */

    skillerctl_color_command(&packet, SK_KEY_ESC, 0xFF0000);
    skillerctl_send_command(handle, &packet);
    skillerctl_color_command(&packet, SK_KEY_F1,  0x00FF00);
    skillerctl_send_command(handle, &packet);
    skillerctl_color_command(&packet, SK_KEY_F2,  0x0000FF);
    skillerctl_send_command(handle, &packet);

    /* skillerctl_disable_command(&packet); */
    /* skillerctl_send_command(handle, &packet); */

    libusb_release_interface(handle, 1);
    libusb_attach_kernel_driver(handle, 1);
    libusb_close(handle);
} 

int main() 
{
    libusb_device **list;

    libusb_init(NULL);
    size_t count = libusb_get_device_list(NULL, &list);
    libusb_device *skiller = skillerctl_find_device(list, count);

    stuff(skiller);

    libusb_free_device_list(list, 1);
    libusb_exit(NULL);
}
